--thank you katsy for making the original addon it makes my job way easier i probably would die from trying to code this on my own

local function SafeFreeslot(...)
	for _, item in ipairs({...})
		if rawget(_G, item) == nil
			freeslot(item)
		end
	end
end

SafeFreeslot(
	"MT_S3INSTASHIELD",
	"S_S3INSTASHIELD",
	"S_S3INSTASHIELD1",
	"S_S3INSTASHIELD2",
	"S_S3INSTASHIELD3",
	"S_S3INSTASHIELD4",
	"S_S3INSTASHIELD5",
	"S_S3BATTLESHIELD",
	"S_S3BATTLESHIELD1",
	"S_S3BATTLESHIELD2",
	"S_S3BATTLESHIELD3",
	"S_S3BATTLESHIELD4",
	"S_S3BATTLESHIELD5",
	"S_S3BATTLESHIELD6",
	"S_S3BATTLESHIELD7",
	"SPR_T3SP"
)

mobjinfo[MT_S3INSTASHIELD] = {
	doomednum = -1,
	dispoffset = 1,
	spawnhealth = 1,
	spawnstate = S_S3INSTASHIELD,
	radius = 36*FRACUNIT,
	height = 72*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

states[S_S3INSTASHIELD] = {SPR_T3SP, 0|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD1}
states[S_S3INSTASHIELD1] = {SPR_T3SP, 1|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD2}
states[S_S3INSTASHIELD2] = {SPR_T3SP, 2|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD3}
states[S_S3INSTASHIELD3] = {SPR_T3SP, 3|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD4}
states[S_S3INSTASHIELD4] = {SPR_T3SP, 4|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3INSTASHIELD5}
states[S_S3INSTASHIELD5] = {SPR_T3SP, 5|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_NULL}

states[S_S3BATTLESHIELD] = {SPR_T3SP, 0|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD1}
states[S_S3BATTLESHIELD1] = {SPR_T3SP, 1|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD2}
states[S_S3BATTLESHIELD2] = {SPR_T3SP, 2|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD3}
states[S_S3BATTLESHIELD3] = {SPR_T3SP, 3|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD4}
states[S_S3BATTLESHIELD4] = {SPR_T3SP, 4|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD5}
states[S_S3BATTLESHIELD5] = {SPR_T3SP, 5|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD6}
states[S_S3BATTLESHIELD6] = {SPR_T3SP, 6|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_S3BATTLESHIELD7}
states[S_S3BATTLESHIELD7] = {SPR_T3SP, 7|FF_FULLBRIGHT, 1, A_CapeChase, -16*FRACUNIT, 0, S_NULL}

addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "s3sonic") and not (player.pflags & PF_THOKKED) and not player.powers[pw_super] and not player.powers[pw_invulnerability] and not (All7Emeralds(emeralds) and player.rings >= 50)
		if (CBW_Battle == nil) and (player.powers[pw_shield] != SH_NONE)
			return true
		end
		S_StartSound(player.mo, sfx_s3k42)
		local instashield = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_S3INSTASHIELD)
		instashield.target = player.mo
		instashield.scale = player.mo.scale
		instashield.spritexscale = $*14/10
		instashield.spriteyscale = $*14/10
		player.mo.tracer = instashield
		player.pflags = $|PF_THOKKED & ~PF_SPINNING
		return true
	end
end)

addHook("ShouldDamage", function(sonic, inflictor, source, damage, element)
	if (sonic.tracer) and sonic.tracer.type == MT_S3INSTASHIELD
		if not (element & DMG_DEATHMASK) and (sonic.player.pflags & PF_JUMPED) and inflictor and not (inflictor.type and inflictor.type == MT_EGGMAN_ICON)
		and (CBW_Battle == nil)
			return false
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(insta, mobj)
	if not (insta.z-FixedMul(18*FRACUNIT, insta.scale) > mobj.z+mobj.height) and not(mobj.z-FixedMul(18*FRACUNIT, insta.scale) > insta.z+insta.height)
		if (mobj.valid and (mobj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) or (mobj.flags & MF_PUSHABLE and mobj.flags & MF_SHOOTABLE))) and not (mobj.flags2 & MF2_FRET) and (insta.target.player.pflags & PF_JUMPED)
			P_DamageMobj(mobj, insta, insta.target)
			insta.target.player.canbust = 2
			if P_MobjFlip(insta.target)*insta.target.momz < 0
				insta.target.momz = -$
			end
			if (mobj.info.spawnhealth > 1)
				insta.target.momy = -$
				insta.target.momx = -$
			end
		end
	end
end, MT_S3INSTASHIELD)