mobjinfo[MT_S3INSTASHIELD].name = "insta-shield"
local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true
	
	local three = function(mo,doaction,pressedaction)
		local player = mo.player
		if P_IsObjectOnGround(player.mo)
			player.actiontext = "Boom Kick"
			//blacknide wanted me to make it the stupid sonic boom move im actually so done
			//if you want the super dash just uncomment the line below
			//player.actiontext = "Super Dash"
			player.actionrings = 10
		else
			player.actiontext = "Super Spin Attack"
			player.actionrings = 10
		end
		//Ability start
		if player.actionstate == 0 and doaction == 1 then
			player.actionstate = 1
			player.actiontime = 0
			CBW_Battle.PayRings(player)
		end	
		
		if player.actionstate == 1 
			if player.actiontext == "Super Spin Attack"
				CBW_Battle.ApplyCooldown(player,TICRATE*2)
				player.actiontime = 0
				player.actionstate = 0
				S_StartSound(player.mo, sfx_s3k42)
				S_StartSound(player.mo, sfx_spndsh)
				local instashield = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_S3INSTASHIELD)
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.colorized = true
				instashield.target = player.mo
				instashield.spritexscale = $*14/10
				instashield.spriteyscale = $*14/10
				instashield.scale = 3*player.mo.scale/2
				instashield.destscale = 3*player.mo.scale/2-FRACUNIT/5
				instashield.battle = true
				instashield.state = S_S3BATTLESHIELD

				local ghost2 = P_SpawnGhostMobj(instashield)
				player.mo.tracer = instashield
				player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_THOKKED|PF_JUMPED & ~PF_SPINNING
			elseif player.actiontext == "Super Dash"
				CBW_Battle.ApplyCooldown(player,TICRATE*2)
				player.actiontime = 0
				player.actionstate = 0
				player.drawangle = player.mo.angle
				S_StartSound(mo,sfx_zoom)
				player.mo.crouch = 0
				player.charge = 1
				player.pflags = $ & ~PF_SPINNING
				player.pflags = $ & ~PF_STARTDASH
				for n = 0,5
					local dust = P_SpawnMobjFromMobj(mo,0,0,0,MT_SPINDUST)
					dust.scale = $ * 3/4
					dust.destscale = 2*$
					local angle = (180+P_RandomRange(-36,36))*ANG1+mo.angle
					local speed = mo.scale*P_RandomRange(10,20)
					P_InstaThrust(dust,angle,speed)
				end
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.colorized = true
				ghost.color = SKINCOLOR_WHITE
				P_InstaThrust(ghost, player.mo.angle, -19*FRACUNIT)
				ghost.destscale = player.mo.scale*3/4

				player.powers[pw_flashing] = 8
				P_TryMove(player.mo, 
					player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, 196*FRACUNIT),
					player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, 196*FRACUNIT)
				)
				P_InstaThrust(player.mo, player.mo.angle, 38*FRACUNIT)
				player.mo.state = S_PLAY_RUN
			elseif player.actiontext == "Boom Kick"
				CBW_Battle.ApplyCooldown(player,TICRATE*2)
				player.actiontime = 0
				player.actionstate = 0
				player.drawangle = player.mo.angle
				S_StartSound(mo,sfx_zoom)
				player.mo.crouch = 0
				player.charge = 1
				player.pflags = $ & ~PF_SPINNING
				player.pflags = $ & ~PF_STARTDASH
				player.pflags = $ & PF_JUMPED
				for n = 0,5
					local dust = P_SpawnMobjFromMobj(mo,0,0,0,MT_SPINDUST)
					dust.scale = $ * 3/4
					dust.destscale = 2*$
					local angle = (180+P_RandomRange(-36,36))*ANG1+mo.angle
					local speed = mo.scale*P_RandomRange(10,20)
					P_InstaThrust(dust,angle,speed)
				end
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.colorized = true
				ghost.color = SKINCOLOR_WHITE
				P_InstaThrust(ghost, player.mo.angle, -19*player.mo.scale)
				ghost.destscale = player.mo.scale*3/4

				P_InstaThrust(player.mo, player.mo.angle, 60*player.mo.scale)
				P_SetObjectMomZ(player.mo, 8*FRACUNIT, true)
				player.mo.state = S_STKICK
			end
		end
	end

	CBW_Battle.SkinVars["s3sonic"] = {
		weight = 110,
		shields = 1, 
		special = three,
		guard_frame = 2,
		sprites = {}
	}
end)

addHook("MobjCollide", function(target, inflictor)
	if (target.valid) 
	and ((target.player) or (target.flags & MF_ENEMY) or (target.flags & MF_BOSS))
	and (inflictor.valid) and (inflictor.type == MT_S3INSTASHIELD) and (inflictor.target.player) and (inflictor.target.valid) and (inflictor.target.skin == "s3sonic")
	and not (target.player.powers[pw_invulnerability])
	and not (target.player.powers[pw_flashing])
	and not (inflictor.target == target)
	and (target.z + target.height + target.momz >= inflictor.z + inflictor.target.momz)
	and (target.z + target.height + target.momz <= inflictor.z + inflictor.target.momz + inflictor.height)
		P_DamageMobj(target, inflictor, inflictor.target)
		target.momx = 0
		target.momy = 0
		return false
	end
end, MT_PLAYER)