// guh x2
// i love copypasting my code --seezee

COM_AddCommand("s3_menu", function(player)
	if (player.mo and player.mo.valid and P_IsObjectOnGround(player.mo) and (player.playerstate == PST_LIVE) and (player.speed < FRACUNIT) and (player.powers[pw_flashing] == 0))
		if (player.s3menu == nil)
			player.s3menu = 1
			player.s3menu_ranout = 0
			player.s3curmus = S_MusicName(player)
			if (CV_FindVar("s3_musicversion").string == "Final")
				COM_BufInsertText(player, "tunes s3mnfn")
			else
				COM_BufInsertText(player, "tunes s3mnpr")
			end
		else
			if (player.s3menu == 1)
				local music = player.s3curmus
				if (music == nil) then music = mapheaderinfo[gamemap].musname end
				player.s3menu = 0
				COM_BufInsertText(player, "tunes -default")
				S_ChangeMusic(music, true, player)
				player.powers[pw_flashing] = TICRATE/2

				if (player.s3menu_ranout == 1)
					S_ChangeMusic(mapheaderinfo[gamemap].musname, true, player)
					player.s3menu_ranout = 0
				end
			else
				player.s3menu = 1
				player.s3menu_ranout = 0
				player.s3curmus = S_MusicName(player)
				if (CV_FindVar("s3_musicversion").string == "Final")
					COM_BufInsertText(player, "tunes s3mnfn")
				else
					COM_BufInsertText(player, "tunes s3mnpr")
				end
			end
		end
	else
		CONS_Printf(player, "something tells me you can't do this rn")
	end
end)

addHook("PreThinkFrame", do
	for player in players.iterate()
		if (player.mo and player.mo.valid)
			player.s3menu_pressed = $ or 0
			player.s3menu_confirmpressed = $ or 0
			player.s3menu_choice = $ or 0
			player.s3menu_timer = $ or 0
			player.s3menu = $ or 0
			player.s3menu_ranout = $ or 0
			if (player.s3menu == 1)
				if (player.s3menu_ranout == 0)
					if (player.powers[pw_sneakers] == 1)
					or (player.powers[pw_invulnerability] == 1)
						player.s3menu_ranout = 1
					end
				end
				player.powers[pw_nocontrol] = 2
				player.s3menu_timer = $ + 1
				if (player.cmd.forwardmove > 20) and (player.s3menu_pressed == 0)
					player.s3menu_pressed = -1
					player.s3menu_choice = $ - 1
					S_StartSound(nil,sfx_s3k5b,player)
				elseif (player.cmd.forwardmove < -20) and (player.s3menu_pressed == 0)
					player.s3menu_pressed = 1
					player.s3menu_choice = $ + 1
					S_StartSound(nil,sfx_s3k5b,player)
				elseif (player.cmd.forwardmove == 0)
					player.s3menu_pressed = 0
				end

				if (player.s3menu_choice < 0)	
					if (player == server or IsPlayerAdmin(player))
						player.s3menu_choice = 7
					else
						player.s3menu_choice = 4
					end
				end

				if (player.s3menu_choice > 7)
				or ((player.s3menu_choice > 5) and not (player == server or IsPlayerAdmin(player)))
					player.s3menu_choice = 0
				end

				if (player.cmd.buttons & BT_USE)
					player.s3menu = 0
					player.s3menu_pressed = 0
					player.s3menu_confirmpressed = 0
					player.s3menu_timer = 0
					player.s3menu_choice = 0
					local music = player.s3curmus
					if (music == nil) then music = mapheaderinfo[gamemap].musname end

					player.powers[pw_flashing] = TICRATE/2
					COM_BufInsertText(player, "tunes -default")
					S_ChangeMusic(music, true, player)

					if (player.s3menu_ranout == 1)
						S_ChangeMusic(mapheaderinfo[gamemap].musname, true, player)
						player.s3menu_ranout = 0
					end
				end

				if (player.cmd.buttons & BT_JUMP) and (player.s3menu_confirmpressed == 0)
					player.s3menu_confirmpressed = 1
					S_StartSound(nil,sfx_kc48,player)

					local changeThis = "s3_music"
					if (player.s3menu_choice == 1)
						changeThis = "s3_musicversion"
					elseif (player.s3menu_choice == 2)
						changeThis = "s3_choppy"
					elseif (player.s3menu_choice == 3)
						changeThis = "s3_camera"
					elseif (player.s3menu_choice == 6)
						changeThis = "s3_keeprings"
					elseif (player.s3menu_choice == 7)
						changeThis = "s3_keepshields"
					elseif (player.s3menu_choice == 4)
						changeThis = "s3_rings"
					elseif (player.s3menu_choice == 5)
						changeThis = "s3_rollangle"
					end
					COM_BufInsertText(player, "add "+changeThis+" 1")

					if (CV_FindVar("s3_musicversion").string == "Final")
						COM_BufInsertText(player, "tunes s3mnfn")
					else
						COM_BufInsertText(player, "tunes s3mnpr")
					end
				end
				
				if not (player.cmd.buttons & BT_JUMP)
					player.s3menu_confirmpressed = 0
				end
			else
				player.s3menu_pressed = 0
				player.s3menu_confirmpressed = 0
				player.s3menu_timer = 0
				player.s3menu_choice = 0
			end
		end
	end
end)

addHook("ShouldDamage", function(mo, guh)
	if not guh return end
	if (mo.valid) and (mo.player) and (mo.player.s3menu)
		return false
	end
end, MT_PLAYER)

local function drawMenu(v, player)
	if not (player.mo) return end
	if (player.playerstate == PST_DEAD) return end
	if not (player.s3menu) return end
	local menuColors = {0,0,0,0,0,0,0,0}
	local menuOptions = {CV_FindVar("s3_music").string, CV_FindVar("s3_musicversion").string, CV_FindVar("s3_choppy").string, CV_FindVar("s3_camera").string, CV_FindVar("s3_rings").string, CV_FindVar("s3_rollangle").string, CV_FindVar("s3_keeprings").string, CV_FindVar("s3_keepshields").string}
	local menuDetail = {
			"Turn on Sonic 3 music for powerups and such.", 
			"Change your music preference (Final/Prototype)",
			"Sonic's sprite rotation will turn choppy when on.",
			"Looking up and down modifies what your camera does.",
			"Losing/shooting rings are turned into S3 Rings.",
			"Makes Sonic's sprite be affected by the slope's angle.",
			"Keeps your current rings inbetween levels.",
			"Keeps your current shield inbetween levels."
		}
	menuColors[player.s3menu_choice+1] = V_YELLOWMAP 

	//bg
	v.drawFill(0,0,320,200,31)
	v.drawStretched(0, sin((player.s3menu_timer)*ANG2)*5, v.dupx()*FRACUNIT/2, v.dupy()*FRACUNIT/2, v.cachePatch("S3MENU"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	v.draw((player.s3menu_timer)%320,0, v.cachePatch("S3HUDB"),V_PERPLAYER|V_SNAPTOTOP)
	v.draw((player.s3menu_timer)%320,200, v.cachePatch("S3HUDA"),V_PERPLAYER|V_SNAPTOBOTTOM)

	v.drawString(160, 180, menuDetail[player.s3menu_choice+1], V_SNAPTOBOTTOM, "thin-center")

	//player options
	v.draw(160, 21, v.cachePatch("S3PLAYER"), V_SNAPTOTOP)
	v.drawString(40, 55, "MUSIC: "+tostring(menuOptions[1]), V_SNAPTOTOP|menuColors[1])
	v.drawString(40, 65, "MUSIC CHOICE: "+tostring(menuOptions[2]), V_SNAPTOTOP|menuColors[2])
	v.drawString(40, 75, "S3 CHOPPY ROTATION: "+tostring(menuOptions[3]), V_SNAPTOTOP|menuColors[3])
	v.drawString(40, 85, "S3 CAMERA STYLE: "+tostring(menuOptions[4]), V_SNAPTOTOP|menuColors[4])
	v.drawString(40, 95, "S3 RINGS STYLE: "+tostring(menuOptions[5]), V_SNAPTOTOP|menuColors[5])
	v.drawString(40, 105, "S3 SLOPE ANGLE: "+tostring(menuOptions[6]), V_SNAPTOTOP|menuColors[6])

	//admin options
	v.draw(160, 121, v.cachePatch("S3ADMIN"), V_SNAPTOBOTTOM)
	//v.drawString(160, 145, "(REGARDING KEEPING RINGS/SHIELDS THROUGH LEVELS)", V_SNAPTOBOTTOM|V_REDMAP, "thin-center")
	v.drawString(40, 155, "KEEP RINGS: "+tostring(menuOptions[7]), V_SNAPTOBOTTOM|menuColors[7])
	v.drawString(40, 165, "KEEP SHIELDS: "+tostring(menuOptions[8]), V_SNAPTOBOTTOM|menuColors[8])

	local offsetY = 55
	local offsetY_min = 0
	offsetY_min = 10*player.s3menu_choice
	if (player.s3menu_choice > 5) 
		offsetY = 155
		offsetY_min = 10*(player.s3menu_choice-6)
	end
	v.draw(20, offsetY+offsetY_min, v.cachePatch("M_CURSOR"), V_SNAPTOLEFT)
end

hud.add(drawMenu, "game")